package cgl.axis.services.WSCTX.wsctx_respond_handler.example;

/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */

import java.util.Properties;
import cgl.axis.services.WSCTX.wsctx_respond_handler.object.SingletonObject;
import cgl.axis.services.WSCTX.wsctx_service.stubs.ContextManagerPortTypeSoapBindingStub;
import cgl.axis.services.WSCTX.wsctx_respond_handler.BootStrap;
/**
 * TestGetContext.java
   @author Mehmet Aktas
   $Date$
   $Revision$
 */

public class TestGetContext {
    private static Properties bootstrap = null;

    public TestGetContext() {
    }

    public cgl.axis.services.WSCTX.wsctx_schema.ContextType testGetContext(){
        cgl.axis.services.WSCTX.wsctx_schema.ContextType result = null;
        try {
            ContextManagerPortTypeSoapBindingStub binding;
            //Loading Properties
            try {
                bootstrap = BootStrap.loadProperties("wsctx_bootstrap.properties");
            } catch (Exception e) {
                e.printStackTrace();
        }
            try {
                cgl.axis.services.WSCTX.wsctx_service.stubs.
                        ContextManagerPortTypeServiceLocator
                        locator = new cgl.axis.services.WSCTX.wsctx_service.stubs.
                                  ContextManagerPortTypeServiceLocator();
                locator.setContextManagerPortTypeEndpointAddress(bootstrap.
                        getProperty("wsctxWSDL"));
                binding = (cgl.axis.services.WSCTX.wsctx_service.stubs.
                           ContextManagerPortTypeSoapBindingStub)
                          locator.getContextManagerPortType();
            } catch (javax.xml.rpc.ServiceException jre) {
                if (jre.getLinkedCause() != null) {
                    jre.getLinkedCause().printStackTrace();
                }
                throw new junit.framework.AssertionFailedError(
                        "JAX-RPC ServiceException caught: " + jre);
            }
            //create a context
            cgl.axis.services.WSCTX.wsctx_schema.ContextType contexttype =
                    new cgl.axis.services.WSCTX.wsctx_schema.ContextType();

            //set context manager service
            //this is optional
            cgl.axis.services.WSCTX.wsrm_schema.ServiceRefType
                    context_manager_serviceref_type =
                            new cgl.axis.services.WSCTX.wsrm_schema.
                            ServiceRefType();
            context_manager_serviceref_type.setName(
                    bootstrap.getProperty("wsctxWSDL"));
            contexttype.setContextManager(context_manager_serviceref_type);

            //set context responded service address
            //this is mandatory. this is to let Context Service where your
            //Context Respond Handler Service is located.
            cgl.axis.services.WSCTX.wsrm_schema.ServiceRefType
                    context_service_serviceref_type =
                            new cgl.axis.services.WSCTX.wsrm_schema.
                            ServiceRefType();
            context_service_serviceref_type.setName(
                    bootstrap.getProperty("wsctxRespondWSDL"));
            contexttype.setContextService(context_service_serviceref_type);

            //set context uri
            String context_uri = "context://demo/context123";
            cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType identifiertype =
                            new cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType();
            identifiertype.setValue(new org.apache.axis.types.URI(context_uri));
            contexttype.setContextIdentifier(identifiertype);

            //create a GetContents Object
            cgl.axis.services.WSCTX.wsctx_schema.GetContents getcontents =
                    new cgl.axis.services.WSCTX.wsctx_schema.GetContents();

            //set the ContextType object into getContents
            getcontents.setContext(contexttype);

            //Context Service is an asyncronous service
            //Following Singular Class allows you to use the Context Service
            //as if the function call returns a value
            SingletonObject singletonobject = SingletonObject.getSingletonObject();

            //invoke getContext function. it will return ContextType XML object
            result = singletonobject.getContext(binding,  getcontents);
            print(result);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return result;
    }

    public void print(cgl.axis.services.WSCTX.wsctx_schema.ContextType context) {
        if (context != null) {
            System.out.println(
                    "*********************************************************");
            System.out.println(
                    "*********************** CONTEXT *************************");
            cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType type =
                    context.getContextIdentifier();
            if (type != null) {
                System.out.println("context uri = " + type.getValue());
            }

            String message_element = context.getMessageElement();
            if (message_element != null) {
                String message = message_element;
                System.out.println("context data = " + message);
            }

            cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType t = context.
                    getParentContextIdentifier();
            if (t != null) {
                System.out.println("parent context identifier value = " +
                                   t.getValue());
            }

            if (context != null) {
                System.out.println("time out value = " + context.getTimeout());
            }

            if (context != null) {
                cgl.axis.services.WSCTX.wss_schema.TimestampType timestamp =
                        context.getTimestamp();
                if (timestamp != null) {
                    cgl.axis.services.WSCTX.wss_schema.AttributedDateTime ctime =
                            timestamp.getCreated();
                    cgl.axis.services.WSCTX.wss_schema.AttributedDateTime etime =
                            timestamp.getExpires();
                    System.out.println("creation   timestamp = " +
                                       ctime.getAttributedDateTimeValue());
                    System.out.println("expiration timestamp = " +
                                       etime.getAttributedDateTimeValue());
                }
            }

            cgl.axis.services.WSCTX.wsctx_schema.RelatedContext[] rc_array =
                    context.getRelatedContext();
            if (rc_array != null && rc_array.length != 0) {
                cgl.axis.services.WSCTX.wsctx_schema.RelatedContext rc = rc_array[0];
                if (rc.getContextIdentifier() != null) {
                    System.out.println("related context identifier value = " +
                                       rc.getContextIdentifier().getValue());
                }
                if (rc.getAssociationURI() != null) {
                    System.out.println("related context association URI = " +
                                       rc.getAssociationURI().toString());
                }
            }

            cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType[]
                    context_array = context.getChildContextIdentifier();
            if (context_array != null) {
                for (int i = 0; i < context_array.length; i++) {
                    cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType c =
                            context_array[i];
                    if (c != null) {
                        System.out.println("child context identifier value = " +
                                           c.getValue().toString());
                    }
                }
            }
            System.out.println(
                    "*********************************************************");
        } else {
            System.out.println("context = " + context);
        }
    }

    public static void main(String args[]) {
        System.out.println("\n*********** Running TestGetContext ***********");
        TestGetContext testgetcontext = new TestGetContext();
        testgetcontext.testGetContext();
    }

}
