package cgl.axis.services.WSCTX.wsctx_respond_handler.example;

/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */

//import java.io.BufferedReader;
//import org.apache.commons.logging.Log;
//import org.apache.commons.logging.LogFactory;
//import java.util.StringTokenizer;
//import java.io.InputStreamReader;

import java.util.Properties;
import cgl.axis.services.WSCTX.wsctx_respond_handler.object.SingletonObject;
import cgl.axis.services.WSCTX.wsctx_service.stubs.ContextManagerPortTypeSoapBindingStub;
import cgl.axis.services.WSCTX.wsctx_respond_handler.BootStrap;

/**
 * TestSetContext.java
   @author Mehmet Aktas
   $Date$
   $Revision$
 */

public class TestSetContext {
    private static Properties bootstrap = null;

    public TestSetContext() {
    }

    public boolean testSetContext() {
        boolean result = true;

        ContextManagerPortTypeSoapBindingStub binding;
        //Loading Properties
        try {
            bootstrap = BootStrap.loadProperties("wsctx_bootstrap.properties");
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            cgl.axis.services.WSCTX.wsctx_service.stubs.
                    ContextManagerPortTypeServiceLocator
                    locator = new cgl.axis.services.WSCTX.wsctx_service.stubs.
                              ContextManagerPortTypeServiceLocator();
            locator.setContextManagerPortTypeEndpointAddress(bootstrap.
                    getProperty("wsctxWSDL"));
            binding = (cgl.axis.services.WSCTX.wsctx_service.stubs.
                       ContextManagerPortTypeSoapBindingStub)
                      locator.getContextManagerPortType();
        } catch (javax.xml.rpc.ServiceException jre) {
            if (jre.getLinkedCause() != null) {
                jre.getLinkedCause().printStackTrace();
            }
            throw new junit.framework.AssertionFailedError(
                    "JAX-RPC ServiceException caught: " + jre);
            }

        try {
           //create a context
            cgl.axis.services.WSCTX.wsctx_schema.ContextType contexttype =
                    new cgl.axis.services.WSCTX.wsctx_schema.ContextType();

            //set context manager service
            cgl.axis.services.WSCTX.wsrm_schema.ServiceRefType
                    context_manager_serviceref_type =
                            new cgl.axis.services.WSCTX.wsrm_schema.
                            ServiceRefType();
            context_manager_serviceref_type.setName(
                    bootstrap.getProperty("wsctxWSDL"));
            contexttype.setContextManager(context_manager_serviceref_type);

            //set context responded service address
            cgl.axis.services.WSCTX.wsrm_schema.ServiceRefType
                    context_service_serviceref_type =
                            new cgl.axis.services.WSCTX.wsrm_schema.
                            ServiceRefType();
            context_service_serviceref_type.setName(
                    bootstrap.getProperty("wsctxRespondWSDL"));
            contexttype.setContextService(context_service_serviceref_type);

            System.out.println("WS-Context is located at " + bootstrap.getProperty("wsctxWSDL"));
            System.out.println("WS-ContextRespondHandler is located at " + bootstrap.getProperty("wsctxRespondWSDL"));


            //set context uri is mandatory
            //you need to set a userdefined uri to manage your space in Context Service
            String context_uri = "context://demo/context123";
            cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType
                    identifiertype = new cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType();
            identifiertype.setValue(new org.apache.axis.types.URI(context_uri));
            contexttype.setContextIdentifier(identifiertype);

            //set some XML in string format as context data
            //please note: Context data can be any arbitrary XML.
            String context_data = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><Limousine xmlns:tsd=\"http://namespaces.softwareag.com/tamino/TaminoSchemaDefinition\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"></Limousine>";
            contexttype.setMessageElement(context_data);

            //setting parentContextIdentifier is optional
            //if there is a parent context which is stored in Context Service, you could use this
            String p_uri = "parentcontext://some_uri";
            cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType pid = new cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType();
            pid.setValue(new org.apache.axis.types.URI(p_uri));
            contexttype.setParentContextIdentifier(pid);

            //setting childContextIdentifier is optional
            //if there are child contexts which are stored in Context Service, you could use this
            cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType [] child_context = new cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType[1];
            String c_uri = "childcontext://some_uri";
            cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType cid = new cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType();
            cid.setValue(new org.apache.axis.types.URI(c_uri));
            child_context[0] = cid;
            contexttype.setChildContextIdentifier(child_context);

            //setting relatedContextIdentifier is optional
            //if there are related contexts which are stored in Context Service, and
            //you want to associate with current context with an association URI, you could use this
            cgl.axis.services.WSCTX.wsctx_schema.RelatedContext [] related_context =
                     new cgl.axis.services.WSCTX.wsctx_schema.RelatedContext[1];
            cgl.axis.services.WSCTX.wsctx_schema.RelatedContext rc = new cgl.axis.services.WSCTX.wsctx_schema.RelatedContext();
            String cntxt_uri = "relatedcontext://some_uri";
            cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType id = new cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType();
            id.setValue(new org.apache.axis.types.URI(cntxt_uri));
            rc.setContextIdentifier(id);
            rc.setAssociationURI(new org.apache.axis.types.URI("rdf://some_association"));
            related_context[0] = rc;
            contexttype.setRelatedContext(related_context);

            //this is also optional
            //this indicates how long the context information is valid for.
            //if you do not set this, the context infor will be valid forever.
            //if you set this to -1, it will be valid forever as well
            contexttype.setTimeout(-1);

            //create a SetContents Object
            cgl.axis.services.WSCTX.wsctx_schema.SetContents setcontents =
                    new cgl.axis.services.WSCTX.wsctx_schema.SetContents();

            //set a ContextType into SetContents Object
            setcontents.setContext(contexttype);

            //Context Service is an asyncronous service
            //Following Singular Class allows you to use the Context Service
            //as if the function call returns a value
            SingletonObject singletonobject = SingletonObject.getSingletonObject();

            //if the result (boolean value) is true, then the invocation is successful.
            result = singletonobject.setContext(binding, setcontents);
        } catch (Exception ex) {
            ex.printStackTrace();
        }

        return result;
    }

    public static void main(String args[]) {
        System.out.println("\n*********** Running TestSetContext ***********");
        TestSetContext test_setcontext = new TestSetContext();
        boolean result = test_setcontext.testSetContext();
        System.out.println("result = " + result);

    }

}

