package cgl.axis.services.WSCTX.wsctx_respond_handler.listener;

/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */

import cgl.axis.services.WSCTX.wsctx_respond_handler.nb.NBSubscriber;

/**
 * EventListener.java
   @author Mehmet Aktas
   $Date$
   $Revision$
 */

public class EventListener {
    public EventListener() {
    }


    public void onEvent(cgl.axis.services.WSCTX.wsctx_schema.ContextType contexttype) {
        try {
            //HERE you can place your code
            print(contexttype);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void print(cgl.axis.services.WSCTX.wsctx_schema.ContextType context) {
        if (context != null) {
            System.out.println(
                    "*********************************************************");
            System.out.println(
                    "*********************** CONTEXT *************************");
            cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType type =
                    context.getContextIdentifier();
            if (type != null) {
                System.out.println("context uri = " + type.getValue());
            }

            String message_element = context.getMessageElement();
            if (message_element != null) {
                String message = message_element;
                System.out.println("context data = " + message);
            }

            cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType t =
                    context.
                    getParentContextIdentifier();
            if (t != null) {
                System.out.println("parent context identifier value = " +
                                   t.getValue());
            }

            if (context != null) {
                System.out.println("time out value = " + context.getTimeout());
            }

            if (context != null) {
                cgl.axis.services.WSCTX.wss_schema.TimestampType timestamp =
                        context.getTimestamp();
                if (timestamp != null) {
                    cgl.axis.services.WSCTX.wss_schema.AttributedDateTime ctime =
                            timestamp.getCreated();
                    cgl.axis.services.WSCTX.wss_schema.AttributedDateTime etime =
                            timestamp.getExpires();
                    System.out.println("creation   timestamp = " +
                                       ctime.getAttributedDateTimeValue());
                    System.out.println("expiration timestamp = " +
                                       etime.getAttributedDateTimeValue());
                }
            }

            cgl.axis.services.WSCTX.wsctx_schema.RelatedContext[] rc_array =
                    context.getRelatedContext();
            if (rc_array != null && rc_array.length != 0) {
                cgl.axis.services.WSCTX.wsctx_schema.RelatedContext rc =
                        rc_array[0];
                if (rc.getContextIdentifier() != null) {
                    System.out.println("related context identifier value = " +
                                       rc.getContextIdentifier().getValue());
                }
                if (rc.getAssociationURI() != null) {
                    System.out.println("related context association URI = " +
                                       rc.getAssociationURI().toString());
                }
            }

            cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType[]
                    context_array = context.getChildContextIdentifier();
            if (context_array != null) {
                for (int i = 0; i < context_array.length; i++) {
                    cgl.axis.services.WSCTX.wsctx_schema.ContextIdentifierType
                            c =
                                    context_array[i];
                    if (c != null) {
                        System.out.println("child context identifier value = " +
                                           c.getValue().toString());
                    }
                }
            }
            System.out.println(
                    "*********************************************************");
        } else {
            System.out.println("context = " + context);
        }
    }

    public static void main(String[] args) {
        NBSubscriber nb = new NBSubscriber();
        nb.start();
    }


}
